#include "enemy.h"


double ENEMY::ddp = .3;

void ENEMY::spawn(double x, PCONTROLLER* _pc, PLAYER* _player, int m){
    pc = _pc;
    player = _player;

    eye = 0;
    eyeTo = 0;

    kind = _BASIC;

    lives = randInt(1,m+1);

    //printf("%i, %i\n", m,lives);

    int w = randInt(20 + 5*lives,30 + 5*lives);

    VECTOR e; e.set(x,-w);
    VECTOR b; b.set(x,0);
    num.set(b,e,1,w);

    dp.set(0,0);

    mode = SPAWN;

    process = 64;
}
void ENEMY::tick(){
    if (player->process == 0){ hit = false; }
    switch (mode){
        case SPAWN:
            if (process < 0 && dp.y < -2 && num.e.y < 0){
                dp.set(0, randFloat(2,8));
                VECTOR p1; p1.set(num.e.x - num.w*.5,0);
                VECTOR p2; p2.set(num.e.x + num.w*.5,0);
                pc->addInArea(PART, p1, p2, 25);
            }
            else if (process < 0 && num.e.y > 0){
                mode = ORIENT;
                process = 32;
            }

            if (!(process % 32)){
                VECTOR p1; p1.set(num.e.x - num.w*.5,0);
                VECTOR p2; p2.set(num.e.x + num.w*.5,0);
                pc->addInArea(PART, p1, p2, 25);
            }

            process--;
            break;
        case ORIENT:
            if (!process){
                mode = STRIKE;
                eyeTo = -3*dir(num.e.x, player->num.e.x);
                dp.set(randFloat(1.8,2.2)*dir(num.e.x, player->num.e.x), 5);
            }
            process--;
            break;
        case STRIKE:
            if (num.e.y < 0 && dp.y < 0){
                mode = ORIENT;
                process += randInt(16,48);
                dp.set(0,0);

                VECTOR p1; p1.set(num.e.x - num.w*.5,0);
                VECTOR p2; p2.set(num.e.x + num.w*.5,0);
                pc->addAtPoint(PART, p1, 5);
                pc->addAtPoint(PART, p2, 5);
            }
            break;
        case DEAD:
            break;
    }

    moveTo(&eye, eyeTo, 20);

    if (mode != SPAWN && mode != DEAD && num.e.y < 0 && dp.y < 0) { num.e.y = 0; dp.y = 0; dp.x /= 1.4; } //dp.y -= (num.b.y - num. h - num.e.y); }

    if (mode == SPAWN && process < 0){ dp.y -= ddp; }
    if (mode != SPAWN){ dp.y -= ddp; }

        //else { num.e.y += (num.b.y - num.e.y - num. h); }

    num.b += dp;

    num.e.x += dp.x;

    if (num.e.x > W - num.w*.5){ num.e.x = num.b.x = W - num.w*.5; dp.x = 0; }
    if (num.e.x < num.w*.5){ num.e.x = num.b.x = num.w*.5; dp.x = 0; }

    double dif = num.b.y - num.e.y - num.h;

    num.e.y += .2*dif;
    num.b.y -= .2*dif;

    if (player->process > 10){
        if (mode != DEAD && !hit && !(KILL && mode == SPAWN && process > 0)){
            for (double i = 1; i > 0; i -= .1){
                if (num.in( (player->num.e + player->base)*i + (player->num.e + player->sword)*(1-i) )){
                    pc->addAtPoint(PART, (player->num.e + player->base)*i + (player->num.e + player->sword)*(1-i), 5);
                    lives -= 1;
                    if (lives <= 0){
                        mode = DEAD;
                        dp.set(0,3);
                    }
                    else{
                        dp.x = 0;
                        VECTOR knock = num.b - player->num.e;
                        knock.unitEquals();

                        dp += knock*.5;
                        mode = STRIKE;

                        process = 32;
                        //dp.y += 3;
                        hit = true;
                    }
                    return;
                }
            }
        }
    }
}
void ENEMY::render(){
    num.render();
}
void ENEMY::renderEye(){
    QUAD e = num;
    e.b -= e.e;
    e.e.set(0,0);

    e.b.unitEquals();
    e.w = 5;
    e.h = 1;
    e.p = 1;
    e.flex = false;

    VECTOR unit = e.b;
    VECTOR perp = e.b.perp();

    e.e = num.b - unit*2 + perp*eye;
    e.b = num.b - unit + perp*eye;

    glColor3ub(255,0,0);
    e.render();

    glColor4ub(255,0,0,128);
    e.e -= unit;
    e.b += unit;
    e.w += 4;
    e.render();
}

void JUMPER::spawn(double x, PCONTROLLER* _pc, PLAYER* _player, int m){
    pc = _pc;
    player = _player;

    eye = 0;
    eyeTo = 0;

    kind = _JUMPER;

    lives = randInt(1,m);

    iter = randInt(0,100);

    int w = randInt(20 + 5*lives,30 + 5*lives);

    VECTOR e; e.set(x,-w);
    VECTOR b; b.set(x,0);
    num.set(b,e,1,w);

    dp.set(0,0);

    mode = SPAWN;

    process = 32;
}
void JUMPER::tick(){
    if (player->process == 0){ hit = false; }
    switch (mode){
        case SPAWN:
            if (process < 0){
                mode = ORIENT;
                process = randInt(32,64);
                dp.set(0,0);
            }

            if (!(process % 32)){
                VECTOR p1; p1.set(num.e.x - num.w*.5,0);
                VECTOR p2; p2.set(num.e.x + num.w*.5,0);
                pc->addInArea(PART, p1, p2, 25);
            }

            process--;
            break;
        case ORIENT:
            if (!process){
                mode = STRIKE;
                //eyeTo = -3*dir(num.e.x, player->num.e.x);
                int t = 64;
                dp.set((player->num.e.x - num.e.x)/t, t*.5*ddp);

                VECTOR p1; p1.set(num.e.x - num.w*.5,0);
                VECTOR p2; p2.set(num.e.x + num.w*.5,0);
                pc->addAtPoint(PART, p1, 15);
                pc->addAtPoint(PART, p2, 15);
            }
            process--;
            break;
        case STRIKE:
            if (num.e.y < 0 && dp.y < 0){
                mode = ORIENT;
                process = randInt(32,64);
                dp.set(0,0);

                VECTOR p1; p1.set(num.e.x - num.w*.5,0);
                VECTOR p2; p2.set(num.e.x + num.w*.5,0);
                pc->addAtPoint(PART, p1, 15);
                pc->addAtPoint(PART, p2, 15);
            }
            break;
        case DEAD:
            break;
    }

    moveTo(&eye, eyeTo, 20);

    if (mode == SPAWN && process < 0){ dp.y -= ddp; }
    if (mode == STRIKE || mode == DEAD){ dp.y -= ddp; }

    if (mode != SPAWN && mode != DEAD && num.e.y < 0 && dp.y < 0) { num.e.y = 0; dp.y = 0; } //dp.y -= (num.b.y - num. h - num.e.y); }
    //else { num.e.y += (num.b.y - num.e.y - num. h); }

    num.b += dp;
    if (mode == DEAD){ num.e += dp; }

    //num.e.x += dp.x;

    if (num.e.x > W - num.w*.5){ num.e.x = num.b.x = W - num.w*.5; dp.x = 0; }
    if (num.e.x < num.w*.5){ num.e.x = num.b.x = num.w*.5; dp.x = 0; }

    if (mode != DEAD){
        VECTOR dif = (num.b - num.e).unit() * ((num.b - num.e).magn() - num.h);
        num.e += dif*.2;
    }
    //num.b -= dif*.2;

    if (player->process > 10){
        if (mode != DEAD && !hit && !(KILL && mode == SPAWN && process > 0)){
            for (double i = 1; i > 0; i -= .1){
                if (num.in( (player->num.e + player->base)*i + (player->num.e + player->sword)*(1-i) )){
                    pc->addAtPoint(PART, (player->num.e + player->base)*i + (player->num.e + player->sword)*(1-i), 5);
                    lives -= 1;
                    if (lives <= 0){
                        mode = DEAD;
                        dp.set(0,3);
                    }
                    else{
                        dp.set(0,3);
                        //dp.y += 3;
                        mode = ORIENT;
                        hit = true;
                    }
                    return;
                }
            }
        }
    }
}
void JUMPER::render(){
    num.render();
}
void JUMPER::renderEye(){
    QUAD e = num;
    e.b -= e.e;
    e.e.set(0,0);

    e.b.unitEquals();
    e.w = 5;
    e.h = 1;
    e.p = 1;
    e.flex = false;

    VECTOR unit = e.b;
    VECTOR perp = e.b.perp();

    e.e = num.b - unit*2 - perp*eye;
    e.b = num.b - unit - perp*eye;

    glColor3ub(255,0,0);
    e.render();

    glColor4ub(255,0,0,128);
    e.e -= unit;
    e.b += unit;
    e.w += 4;
    e.render();
}


SWORDBASE::SWORDBASE(){
    s[0].set(-14,90);
    b[0].set(0,18);
}
VECTOR SWORDBASE::getSVector(int iter, int process, unsigned char type, int facing){
    VECTOR toReturn;
    if (process > 0){
        switch (type){
            case 0:
                if (facing == 0){
                    toReturn.set(160*sin(M_PI*(process-16)/64.)*dir(0,side), b[type].y - 50 + 140*cos(M_PI*(process-16)/32.));
                    if(!(process%3)){ process++; }
                }
                else{
                    toReturn.set(-40*(M_PI*(process-16)/48. - 2*sqrt(cos(M_PI*(process-16)/32.)))*facing, b[type].y + 15 + 70*sin(M_PI*(process-16)/32.));
                }
                break;
        }
    }
    else{
        if (facing == 0){
            toReturn.set(s[type].x*dir(0,side), s[type].y + 4*sin(.1*iter));
        }
        else{
            toReturn.set(s[type].x*facing, s[type].y + 4*sin(.1*iter));
        }
    }
    return toReturn;
}
VECTOR SWORDBASE::getBVector(int iter, int process, unsigned char type, int facing){
    VECTOR toReturn;
    if (process > 0){
        switch (type){
            case 0: toReturn.set(10*sin(M_PI*(process-16)/32.)*facing, b[type].y - 5*cos(M_PI*(process-16)/32.)); break;
        }
    }
    else{
        toReturn.set(b[type].x*facing, b[type].y + 2*cos(.1*iter));
    }
    return toReturn;
}

void PLAYER::spawn(double x, PCONTROLLER* _pc){
    pc = _pc;
    kind = _PLAYER;

    liftingLeft = true;

    VECTOR up; up.set(0,1);

    facing = 1;

    eye = 0;
    eyeTo = 0;

    VECTOR e; e.set(x,0);
    VECTOR b; b.set(x,50);

    dp.set(0,0);

    sword = sb.s[0];
    base = sb.b[0];

    foot1 = +10;
    foot2 = -10;

    num.set(b,e,1,30);

    VECTOR tf1; tf1.set(num.b.x - foot1, 0);
    VECTOR tf2; tf2.set(num.b.x - foot2, 0);

    QUAD f; f.set(tf1 + up*(num.w*.25), tf1,1, num.w*.25);
    f1 = f;
    f.set(tf2 + up*(num.w*.25), tf2,1, num.w*.25);
    f2 = f;

    pause = 0;
    process = 0;

    swingType = SWIPE;
}
void PLAYER::swing(bool left){
    if (!process){
        process = 42;
        sb.side = sword.x;
    }
}
void PLAYER::jump(){
    if (grounded){
        dp.y = 8;
        grounded = false;
    }
}
void PLAYER::fall(){
    if (dp.y > -4){ dp.y = -4; }
}
void PLAYER::move(int d){
    ///if (!pause){
        dp.x += 1*d;
    ///}
}
void PLAYER::struckHere(VECTOR v){
    pc->addAtPoint(PART, v, 5);
    if(!pause){ pause = 12; if (process){ process = 8; } }
}

void PLAYER::tick(){
    iter++;

    //eyeTo = ;

    moveTo(&eye, -facing*3, 10);

    if (process && pause < 5){ process -= 2; }
    if (pause){ pause--; }

    dp.x /= 1.2;
    dp.y -= ddp;

    if (num.e.y + dp.y < 0){ num.e.y = 0; num.b.y = num.h; dp.y = 0; grounded = true; }

    num += dp;

    if (liftingLeft){
        foot1 += .5*dp.x;
        foot2 -= .5*dp.x;
    }
    else{
        foot1 -= .5*dp.x;
        foot2 += .5*dp.x;
    }

    if (foot1 > 10 || foot1 < -10 || foot2 > 10 || foot2 < -10){
        liftingLeft = !liftingLeft;
    }

    if (abs(dp.x) < .5){
        foot1 = 10;
        foot2 = -10;
    }

    int buf = 15;

    if (num.e.x < buf){ num.e.x = num.b.x = buf; }
    if (num.e.x > W - buf){ num.e.x = num.b.x = W - buf; }

    if (pause < 5){
        if (process < 10){
            if (facing == 0){
                facing = dir(0,sb.side);
            }
            sword.rotateTo(sb.getSVector(iter, process-10,swingType, facing), 8);
            base.rotateTo(sb.getBVector(iter, process-10,swingType, facing), 8);
        }
        else{
            sword.rotateTo(sb.getSVector(iter, process-10,swingType, facing), 3);
            base.rotateTo(sb.getBVector(iter, process-10,swingType, facing), 3);
        }
    }

    //num.tick();

    if (sword.y + num.e.y < 0 || sword.x + num.e.x > W || sword.x + num.e.x < 0){

        if (sword.x + num.e.x > W){ sword.x = W - num.e.x; }
        if (sword.x + num.e.x < 0){ sword.x = -num.e.x; }
        if (sword.y + num.e.y < 0){ sword.y = -num.e.y; }

        pc->addAtPoint(PART, sword + num.e, 5);
        if(!pause){ pause = 12; if (process){ process = 8; } }
    }
}
void PLAYER::render(){
    //num.render();
    VECTOR up; up.set(0,1);

    num.b.y = num.e.y + num.h + 2*cos(.1*iter);

    VECTOR h2 = num.b; h2.y -= num.w*.5;
    QUAD h; //h.set(num.b + up*(2*cos(.1*iter)), h2 + up*(2*cos(.1*iter)),1,num.w*.5);
    h.set(num.b, h2,1,num.w*.5);
    h.render();

    if (num.e.y > 5){
        foot1 = 10;
        foot2 = -10;
    }

    VECTOR tf1; VECTOR tf2;
        tf1.set(num.b.x - foot1, (!liftingLeft)*4*cos(M_PI*foot1/20.));
        tf2.set(num.b.x - foot2, (liftingLeft)*4*cos(M_PI*foot2/20.));
//    if (liftingLeft){
//        foot1 += .5*dp.x;
//        foot2 -= .5*dp.x;
//    }
//    else{
//        foot1 -= .5*dp.x;
//        foot2 += .5*dp.x;
//    }

    QUAD f; f.set(tf1 + up*(num.w*.25), tf1,1, num.w*.25);
    if (num.e.y > 5){
        f += up*(num.e.y - 5 - 4*facing);
    }
//    else if(abs(dp.x) > .5 && (iter/20)%2){
//        f += up*2;
//    }
    //f1.b.rotateTo(f.b,5);
    //f1.e.rotateTo(f.e,5);
    f.render();

    f.set(tf2 + up*(num.w*.25), tf2,1,num.w*.25);
    if (num.e.y > 5){
        f += up*(num.e.y - 5 + 4*facing);
    }
//    else if(abs(dp.x) > .5 && !((iter/20)%2)){
//        f += up*2;
//    }
    //f2.b.rotateTo(f.b,5);
    //f2.e.rotateTo(f.e,5);
    f.render();

    VECTOR h1; h1 = num.e + base*.97 + sword*.03;
    VECTOR h3; h3 = num.e + base*.87 + sword*.13;

    h.set(h1 + up*(.5*num.w*.25),h1 - up*(.5*num.w*.25),1,num.w*.25);
    h.render();

    h.set(h3 + up*(.5*num.w*.25),h3 - up*(.5*num.w*.25),1,num.w*.25);
    h.render();

    QUAD s; s.set((num.e + base), (num.e + sword), 1.05, 4);
    s.render();
}
void PLAYER::renderEye(){
    QUAD e = num;
    e.b -= e.e;
    e.e.set(0,0);

    e.b.unitEquals();
    e.w = 5;
    e.h = 1;
    e.p = 1;
    e.flex = false;

    VECTOR unit = e.b;
    VECTOR perp = e.b.perp();

    e.e = num.b - unit*2 + perp*eye;
    e.b = num.b - unit + perp*eye;

    glColor3ub(0,255,255);
    e.render();

    glColor4ub(0,255,255,128);
    e.e -= unit;
    e.b += unit;
    e.w += 4;
    e.render();
}

void BIRD::spawn(double x, PCONTROLLER* _pc, PLAYER* _player, int m){
    pc = _pc;
    player = _player;

    eye = 0;
    eyeTo = 0;

    kind = _BIRD;

    lives = randInt(1,m);

    iter = randInt(0,100);

    int w = randInt(10 + 5*lives,20 + 5*lives);

    VECTOR e; e.set(x,-w);
    VECTOR b; b.set(x,0);
    num.set(b,e,1,w);

    wing.set(-.5*num.w, -1.5*num.w);

    dp.set(0,0);

    mode = SPAWN;

    process = 32;
}
void BIRD::tick(){
    if (player->process == 0){ hit = false; }
    if (mode != DEAD){ iter++; }

    double dist;

    double speed = .25 + .005*num.w;

    switch (mode){
        case SPAWN:
            if (process < 0 && dp.y < -2 && num.e.y < 0){
                dp.set(0, randFloat(2,8));
                VECTOR p1; p1.set(num.e.x - num.w*.5,0);
                VECTOR p2; p2.set(num.e.x + num.w*.5,0);
                pc->addInArea(PART, p1, p2, 25);
            }
            else if (process < 0 && num.e.y > 0){
                mode = ORIENT;
                process = 32;
                dp.y += 3;
            }

            if (!(process % 32)){
                VECTOR p1; p1.set(num.e.x - num.w*.5,0);
                VECTOR p2; p2.set(num.e.x + num.w*.5,0);
                pc->addInArea(PART, p1, p2, 25);
            }

            process--;
            break;
        case ORIENT:
            dist = num.b.y;
            dist = ((H - 100) - dist)/20;
            if (dist > 6*ddp){ dist = 6*ddp; }
            dp.y = (dist + 8*ddp*cos(speed*iter));

            dist = abs(num.e.x-player->num.e.x);
            if (dist < num.w){
                if (!randInt(0,16)){
                    mode = STRIKE;
                    eyeTo = 0;
                    dp.x = 0;
                }
            }
            if (dist > 200 || !randInt(0,100)){
                eyeTo = -3*dir(num.e.x, player->num.e.x);
                dp.x = dir(num.e.x, player->num.e.x)*randFloat(1.8,2.2);
            }
            process--;
            break;
        case STRIKE:
            dp.y -= 2*ddp;
            if (num.e.y < 0 && dp.y < 0) { num.b.y -= num.e.y; num.e.y = 0; dp.y = 0; mode = ORIENT; }
            break;
        case DEAD:
            break;
    }

    moveTo(&eye, eyeTo, 20);


    if (mode == SPAWN && process < 0){ dp.y -= ddp; }
    if (mode == DEAD){ dp.y -= ddp; }

    if (mode != SPAWN && mode != DEAD && num.e.y < 0 && dp.y < 0) { num.b.y -= num.e.y; num.e.y = 0; dp.y = 0; } //dp.y -= (num.b.y - num. h - num.e.y); }
    //else { num.e.y += (num.b.y - num.e.y - num. h); }
     //dp.y -= (num.b.y - num. h - num.e.y); }

    if (mode != SPAWN && mode != DEAD){
        VECTOR wingTo;
        wingTo.set(2.5*num.w + 2*num.w*sin(speed*iter), 2*num.w*cos(speed*iter));

        wing.rotateTo(wingTo, 10);
    }

    //dp.y -= .5*ddp + ddp*cos(speed*iter);

    num.b.x += dp.x*cos(speed*iter)*cos(speed*iter);
    num.e.x += dp.x*cos(speed*iter)*cos(speed*iter);

    num.b.y += dp.y;
    num.e.y += dp.y;

    if (num.e.x > W - num.w*.5){ num.e.x = num.b.x = W - num.w*.5; dp.x = -dp.x; }
    if (num.e.x < num.w*.5){ num.e.x = num.b.x = num.w*.5; dp.x = -dp.x; }

//    double dif = num.b.y - num.e.y - num.h;
//
//    num.e.y += .2*dif;
//    num.b.y -= .2*dif;

    if (player->process > 10){
        if (mode != DEAD && !hit && !(KILL && mode == SPAWN && process > 0)){
            for (double i = 1; i > 0; i -= .1){
                if (num.in( (player->num.e + player->base)*i + (player->num.e + player->sword)*(1-i) )){
                    pc->addAtPoint(PART, (player->num.e + player->base)*i + (player->num.e + player->sword)*(1-i), 5);
                    lives -= 1;
                    if (lives <= 0){
                        mode = DEAD;
                        dp.set(0,3);
                    }
                    else{
                        dp.y += 3;
                        mode = ORIENT;
                        hit = true;
                    }
                    return;
                }
            }
        }
    }
}
void BIRD::render(){
    num.render();

    VECTOR perp = wing.perp();

    double span = 1.8*num.w;

    if (wing.magn() > 2*span){ return; }

    double ang = acos(wing.magn()/(2*span));

    perp *= (wing.magn()*.5)*sin(ang);
    perp += (wing*.5);

    QUAD w1; QUAD w2;

    w1.set(num.b, num.b + perp, 1.1, 8);
    w2.set(num.b + perp, num.b + wing, 1.1, 4);

    w1.render(); w2.render();

    perp.x = -perp.x;
    wing.x = -wing.x;

    w1.set(num.b, num.b + perp, 1.1, 8);
    w2.set(num.b + perp, num.b + wing, 1.1, 4);

    w1.render(); w2.render();
    wing.x = -wing.x;
}
void BIRD::renderEye(){
    QUAD e = num;
    e.b -= e.e;
    e.e.set(0,0);

    e.b.unitEquals();
    e.w = 5;
    e.h = 1;
    e.p = 1;
    e.flex = false;

    VECTOR unit = e.b;
    VECTOR perp = e.b.perp();

    e.e = num.e + unit*2 + perp*eye;
    e.b = num.e + unit + perp*eye;

    glColor3ub(255,0,0);
    e.render();

    glColor4ub(255,0,0,128);
    e.e -= unit;
    e.b += unit;
    e.w += 4;
    e.render();
}

void SNAKE::spawn(double x, PCONTROLLER* _pc, PLAYER* _player){
    pc = _pc;
    player = _player;

    eye = 0;
    eyeTo = 0;

    kind = _SNAKE;

    last = 0;

    lives = 5;

    if (x > W*.5){ x = W - 40*2*sin(2); facing = -1; }
    if (x < W*.5){ x = 40*2*sin(2); facing = 1; }

    defhead.set(x + facing*50, H - 50);

    h = (H-10)/10.;

    for (int i = 10; i >= 0; i--){
        VECTOR v;

        v.set(x - 10*facing*sin(M_PI*(i/10.))*i, (H-10)*i/10.);
        def.push_back(v);

        v.set(x, (H-10)*i/10. - (H-10));
        pos.push_back(v);
    }

    def[10].y -= 10;

    w = randInt(15,25);

    VECTOR e; e.set(x,-w);
    VECTOR b; b.set(x,0);
    num.set(b,e,1,w);

    dp.set(0,0);

    mode = SPAWN;

    process = 32;
}
void SNAKE::tick(){
    if (mode != DEAD){ iter++; }

    switch (mode){
        case SPAWN:
            if (process < 0){
                VECTOR p1; p1.set(def[10].x - w*.5,0);
                VECTOR p2; p2.set(def[10].x + w*.5,0);
                pc->addAtPoint(PART, p1, 1);
                pc->addAtPoint(PART, p2, 1);

                for (int i = 0; i < 11; i++){
                    VECTOR dp2;
                    dp = def[i] - pos[i];
                    dp2 = dp;

                    for (int j = 0; j < 11; j++){
                        if (pos[i].y < def[j].y){
                            dp2 += def[j] - pos[i];
                        }
                    }
                    if (dp.magn() > 60){
                        if (pos[i].y < 0){
                            dp2.x = 0;
                        }
                        dp2.unitEquals();
                        dp2 *= 4;
                        pos[i] += dp2;
                    }
                    else{
                        if (dp.magn() < 5){
                            mode = ORIENT;
                            process = 128;
                            tohead = defhead;
                        }
                        pos[i].rotateTo(def[i], 15);
                    }


                }
            }

            if (!(process % 32)){
                VECTOR p1; p1.set(def[10].x - w*.5,0);
                VECTOR p2; p2.set(def[10].x + w*.5,0);
                pc->addInArea(PART, p1, p2, 50);
            }

            process--;
            break;
        case ORIENT:
            if (process < -48){
                tohead = defhead;
                process = 64;
            }
            if (!process){
                if (player->num.e.x - pos[10].x < h*7){
                    mode = STRIKE;
                    tohead = player->num.e;
                    tohead.y = 0;
                }
                else{
                    process = 32;
                }
            }
            process--;
            break;
        case STRIKE:
            if (pos[0].y <= 5){
                mode = ORIENT;
                process = randInt(-32,-1);
                tohead = pos[0];

                VECTOR p1; p1.set(pos[0].x- w*.5,0);
                VECTOR p2; p2.set(pos[0].x + w*.5,0);
                pc->addAtPoint(PART, p1, 15);
                pc->addAtPoint(PART, p2, 15);
            }
            break;
        case DEAD:
            for (int i = 0; i < 11; i++){
                dp.y -= ddp;
                pos[i] += dp;
            }
            break;
    }

    if (mode == ORIENT || mode == STRIKE){
        dp = tohead - pos[0];

        if (dp.magn() < 40){
            pos[0].rotateTo(tohead, 10*(mode == ORIENT)+ 5*(mode == STRIKE));
        }
        else{
            dp.unitEquals();
            dp *= 4*(mode == ORIENT)+ 8*(mode == STRIKE);
            pos[0] += dp;
        }

        for (int i = 1; i < 10; i++){

            double dif = (pos[i] - pos[i+1]).magn() - h;

            pos[i+1] += (pos[i] - pos[i+1])*(.02*dif);

//            dp = def[i+1] - pos[i+1];
//
//            dp.
//
//            pos[i+1] + dp

            //pos[i+1].rotateTo(def[i+1], 20);

            //num.b.y -= .2*dif;


        }
    }

    moveTo(&eye, eyeTo, 20);

    if (last){
        last--;
    }

    if (player->process > 10){
        if (mode != DEAD && !(mode == SPAWN && process > 0)){
            for (double j = 1; j > 0; j -= .1){
                QUAD segment;

                VECTOR v; v.set(facing, 0);

                for (int i = 0; i < 10; i++){
                    segment.set(pos[i] + v*(sin(.02*iter)*.05*pos[i].y), pos[i+1] + v*(sin(.02*iter)*.05*pos[i+1].y), 1.1, 20 + 5*(i-2)*(i-2)/25. + 2*(i==0));

                    if (segment.in( (player->num.e + player->base)*i + (player->num.e + player->sword)*(1-i) )){
                        pc->addAtPoint(PART, (player->num.e + player->base)*i + (player->num.e + player->sword)*(1-i), 5);
                        if (last < player->process){
                            last = player->process;
                            lives -= 1;
                            if (lives <= 0){
                                mode = DEAD;
                                dp.set(0,3);
                            }
                            return;
                        }
                    }
                }
            }
        }
    }
}
void SNAKE::render(){
    QUAD segment;

    VECTOR v; v.set(facing, 0);



    for (int i = 0; i < 10; i++){
        segment.set(pos[i] + v*(sin(.02*iter)*.05*pos[i].y), pos[i+1] + v*(sin(.02*iter)*.05*pos[i+1].y), 1.1, w + 5*(i-2)*(i-2)/25. + 2*(i==0));
        if (i == 0){ num = segment; }
        segment.render();
    }
}
void SNAKE::renderEye(){
    QUAD e = num;
    e.b -= e.e;
    e.e.set(0,0);

    e.b.unitEquals();
    e.w = 5;
    e.h = 1;
    e.p = 1;
    e.flex = false;

    VECTOR unit = e.b;
    VECTOR perp = e.b.perp();

    e.e = num.b - unit*2 + perp*eye;
    e.b = num.b - unit + perp*eye;

    glColor3ub(255,0,0);
    e.render();

    glColor4ub(255,0,0,128);
    e.e -= unit;
    e.b += unit;
    e.w += 4;
    e.render();
}

