#include "include.h"
#include "application.h"
#include "math.h"
#include "geometry.h"
#include "particle.h"
#include "loading.h"
#include "enemy.h"

int main(){
    APPLICATION window;
    window.initiate();

    bool KEYS[512]; for(int i = 0; i < 512; i++){ KEYS[i] = false; }

    PCONTROLLER pc(0);

    PLAYER player;
    player.spawn(200, &pc);

//    VECTOR pv2; pv2.set(W+B, H+B);
//    VECTOR pv3; pv3.set(W+B, -B);
    VECTOR pv2; pv2.set(H+B, W+B);
    VECTOR pv3; pv3.set(-B, W+B);

//    for (int i = 0; i < 1000; i++){
//        pc.addInArea(WIND, pv2, pv3, 1);
//
//        pc.tick();
//    }

    std::vector<ENEMY> enemies;
    std::vector<JUMPER> jumpers;
    std::vector<BIRD> birds;
    std::vector<SNAKE> snakes;

    SNAKE snake; snake.spawn(200, &pc, &player);
    ENEMY enemy; enemy.spawn(100, &pc, &player);
    BIRD bird; bird.spawn(200, &pc, &player);
    JUMPER jumper; jumper.spawn(150, &pc, &player);

//    enemies.push_back(enemy);
//    birds.push_back(bird);
//    //snakes.push_back(snake);
//    jumpers.push_back(jumper);

    int iter = 0; int MOUSEX = 0; int MOUSEY = 0;

    FONT font; font.set("font3.bmp",7,7);

    char str[128];

    double INTRO = 1200;

    double tolevel = -1;
    double level = -1;


    char info[7][64] = {"ONCE UPON A TIME...\0",
    "THINGS CAME UP,\0",
    "OUT OF THE GROUND,\0",
    "TO DESTROY THE WORLD...\0",
    "ETC, ETC.",
    "IF YOU FEEL LIKE IT, YOU CAN DEFEAT THEM!\0",
    "A, W, S, D TO MOVE, c, a, d TO STRIKE.\0"
    };

    char check[64] = "(CHECKPOINT SAVED)\0";
    double checkx = -1;

    int checkseed = 0;
    int curseed = 0;
    int wave = 0;
    int dead = 0;

    while (true){
        iter++;

        glDisable(GL_DEPTH_TEST);


            SDL_Event event;
        while (SDL_PollEvent(&event)) {
            switch (event.type) {
                case SDL_KEYDOWN: KEYS[event.key.keysym.sym] = true;  break;
                case SDL_KEYUP:   KEYS[event.key.keysym.sym] = false; break;
                case SDL_MOUSEMOTION:   MOUSEX = event.motion.x; MOUSEY = event.motion.y; break;
                case SDL_MOUSEBUTTONDOWN:   break;
                case SDL_MOUSEBUTTONUP:     break;
//                case SDL_VIDEORESIZE:
//						window.rwid = window.owid = event.resize.w;
//						window.rhgt = window.ohgt = event.resize.h;
//
//						SDL_SetVideoMode(window.rwid, window.rhgt, window.bpp, SDL_OPENGL | SDL_RESIZABLE );
//						glViewport(0, 0, window.rwid, window.rhgt);
//						break;
                case SDL_QUIT: window.quit(); break;
            }
        }
        //glViewport(0, 0, window.rwid*.5*blur, window.rhgt*.5*blur);



//        player.up = (KEYS[SDLK_w] || KEYS[SDLK_UP]);
//        player.down = (KEYS[SDLK_s] || KEYS[SDLK_DOWN]);
//        player.left = (KEYS[SDLK_a] || KEYS[SDLK_LEFT]);
//        player.right = (KEYS[SDLK_d] || KEYS[SDLK_RIGHT]);

        if ((KEYS[SDLK_w])){ player.jump(); }
        if ((KEYS[SDLK_s])){ player.fall(); }

        if ((KEYS[SDLK_RETURN]) && INTRO > 10){ INTRO = 10; }

        //if (KEYS[SDLK_SPACE]){ player.swing(true); }

        player.move((KEYS[SDLK_d]) - (KEYS[SDLK_a]));

        if (!player.process){
            if (!(KEYS[SDLK_d] && KEYS[SDLK_a]) && (KEYS[SDLK_d] || KEYS[SDLK_a])){ player.facing = (KEYS[SDLK_d]) - (KEYS[SDLK_a]); }
            if (KEYS[SDLK_LEFT]){   player.facing = -1; player.swing(true); }
            if (KEYS[SDLK_RIGHT]){  player.facing = 1; player.swing(true); }
            if (KEYS[SDLK_UP]){     player.facing = 0; player.swing(true); }
        }

        if (enemies.size() == 0 && birds.size() == 0 && snakes.size() == 0 && jumpers.size() == 0){
            ///if (wave > 1){ wave--; }
            ///else{
                tolevel++;
                iter = 0;


                srand(curseed);

                randInt(1,((int)level)/5);

                if (tolevel != 5 && tolevel != 10){
                    int val = gaussianPositive(1, 1+sqrt(tolevel)/5);
                    for (int i = 0; i < val; i++){
                        enemy.spawn(randInt(50,W-50), &pc, &player, 2 - (tolevel == 0));
                        enemies.push_back(enemy);
                    }
                }
                if (tolevel >= 5){
                    if (tolevel != 10){
                        int val = gaussianPositive(1*(tolevel >= 5 && tolevel < 10), sqrt(tolevel)/5);
                        for (int i = 0; i < val; i++){
                            bird.spawn(randInt(50,W-50), &pc, &player);
                            birds.push_back(bird);
                        }
                    }
                }
                if (tolevel >= 10){
                    int val = gaussianPositive(1*(tolevel >= 10 && tolevel < 15), sqrt(tolevel)/5);
                    for (int i = 0; i < val; i++){
                        jumper.spawn(randInt(50,W-50), &pc, &player);
                        jumpers.push_back(jumper);
                    }
                }

                curseed = rand();
            ///}
        }

        glTranslated(40,720 - .75*(720 - 1.5*H),0);

        int mx = (MOUSEX - 40)/N;
        //int my = -(MOUSEY - (720 - .75*(720 - 1.5*H)));

        //player.facing = dir(player.num.e.x,mx);

//        pc.addInArea(WIND, pv1, pv2, 1);
        //pc.addInArea(WIND, pv2, pv3, 1);

        //VECTOR v; v.set(100,100);

        if (!dead){
            player.tick();
            pc.tick();

            if (!((int)tolevel%5) && checkx > -.9){
                if (checkx > .001){
                    moveTo(&checkx, 0, 20);
                }
                else if (checkx < .0001){
                    moveTo(&checkx, -1, 20);
                }
                else{
                    moveTo(&checkx, 0, 40);
                }
            }
            if (!(((int)tolevel-1)%5) && level < tolevel && tolevel != 0){
                checkx = 1;
            }

            if (INTRO){
                if (INTRO > 50){ INTRO -= 1; }
                else{ moveTo(&INTRO, 0, 50); }
                if (INTRO < .01){ INTRO = 0; }
            }

            if (!INTRO){

                for (int i = 0; i < enemies.size(); i++){
                    enemies[i].tick();
                    if (enemies[i].mode == DEAD && enemies[i].num.b.y < -100){
                        //pc.addInQuad(DEATH, enemies[i].num, enemies[i].num.a/50);
                        //pc.addInQuad(PART, enemies[i].num, enemies[i].num.a/25);
                        enemies.erase(enemies.begin() + i); i--;
                    }
                }
                for (int i = 0; i < birds.size(); i++){
                    birds[i].tick();
                    if (birds[i].mode == DEAD && birds[i].num.b.y < -100){
                        //pc.addInQuad(DEATH, enemies[i].num, enemies[i].num.a/50);
                        //pc.addInQuad(PART, enemies[i].num, enemies[i].num.a/25);
                        birds.erase(birds.begin() + i); i--;
                    }
                }
                for (int i = 0; i < snakes.size(); i++){
                    snakes[i].tick();
                    if (snakes[i].mode == DEAD && snakes[i].num.b.y < -100){
                        //pc.addInQuad(DEATH, enemies[i].num, enemies[i].num.a/50);
                        //pc.addInQuad(PART, enemies[i].num, enemies[i].num.a/25);
                        snakes.erase(snakes.begin() + i); i--;
                    }
                }
                for (int i = 0; i < jumpers.size(); i++){
                    jumpers[i].tick();
                    if (jumpers[i].mode == DEAD && jumpers[i].num.b.y < -100){
                        //pc.addInQuad(DEATH, enemies[i].num, enemies[i].num.a/50);
                        //pc.addInQuad(PART, enemies[i].num, enemies[i].num.a/25);
                        jumpers.erase(jumpers.begin() + i); i--;
                    }
                }
            }

            moveTo(&level, tolevel, 20);

            VECTOR v; v.set(0,0);
            double w = 0;

            for (int j = 0; j < 4; j++){
                for (int i = 0; i < (j==0)*enemies.size() + (j==1)*birds.size() + (j==2)*jumpers.size() + (j==3)*snakes.size(); i++){

                    switch (j){
                        case 0: if (!enemies[i].mode == DEAD){  v = enemies[i].num.c(); w = enemies[i].num.w; } break;
                        case 1: if (!birds[i].mode == DEAD){    v = birds[i].num.c();   w = birds[i].num.w; }   break;
                        case 2: if (!jumpers[i].mode == DEAD){  v = jumpers[i].num.c(); w = jumpers[i].num.w; } break;
                        case 3: if (!snakes[i].mode == DEAD){   v = snakes[i].num.c();  w = snakes[i].num.w; }  break;
                    }
                    ///if ((v - player.num.c()).magn() < w){
                    if (player.num.in(v)){
                        dead = 32;
                    }
                }
            }
        }
        else{
            dead--;
            if (!dead){
                //printf("HERE!");
                tolevel = 5*(((int)tolevel)/5) - 1;
                player.process = 0;
                curseed = checkseed;
                enemies.clear();
                birds.clear();
                jumpers.clear();
                snakes.clear();
                pc.particles.clear();
                checkx = -1;
            }
        }



//        glMatrixMode(GL_PROJECTION); glLoadIdentity();
//        glOrtho(0,window.rwid,-window.rhgt,0,-100,100);
//
//        glMatrixMode(GL_MODELVIEW); glLoadIdentity();

        GLuint world;

        if (true){
            world = glGenLists(1);
            glNewList(world, GL_COMPILE);

            glBegin(GL_QUADS);

            player.render();

            for (int i = 0; i < enemies.size(); i++){
                enemies[i].render();
            }

            for (int i = 0; i < birds.size(); i++){
                birds[i].render();
            }

            for (int i = 0; i < snakes.size(); i++){
                snakes[i].render();
            }

            for (int i = 0; i < jumpers.size(); i++){
                jumpers[i].render();
            }

            glVertex2d(-B,0);
            glVertex2d(W+B,0);
            glVertex2d(W+B,-B);
            glVertex2d(-B,-B);

            glVertex2d(-B,H+B);
            glVertex2d(W+B,H+B);
            glVertex2d(W+B,H);
            glVertex2d(-B,H);

            glVertex2d(-B,H+B);
            glVertex2d(0,H+B);
            glVertex2d(0,-B);
            glVertex2d(-B,-B);

            glVertex2d(W,H+B);
            glVertex2d(W+B,H+B);
            glVertex2d(W+B,-B);
            glVertex2d(W,-B);

            pc.render();


            for (int i = level; i < level + 2; i++){
                if (i != -1){
                    snprintf(str, 64, "LEVEL %i", i);
                    glPushMatrix();
                    glTranslated(W*.5 - 2*font.getLength(str) - (level - i)*W, H - 16,0);
                    glScaled(4,-4,1);
                    glCullFace(GL_BACK);
                    font.renderWithColor(str,0,0,0,0,0,255);
                    glCullFace(GL_FRONT);
                    glPopMatrix();
                }
            }

            if (!((int)tolevel%5) && checkx > -.9){
                glPushMatrix();
                glTranslated(W*.5 - font.getLength(check) + (checkx)*W, H - 64,0);
                glScaled(2,-2,1);
                glCullFace(GL_BACK);
                font.renderWithColor(check,0,0,0,0,0,255);
                glCullFace(GL_FRONT);
                glPopMatrix();
            }

            glEnd();

            glEndList();
        }

        if (!dead){ glClearColor( 255, 255, 255, 255 ); }
        else{       glClearColor( 255, 0, 0, 255 ); }

        glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

        glMatrixMode(GL_PROJECTION); glLoadIdentity();
        glOrtho(0,window.rwid,window.rhgt,0,-100,100);

        glMatrixMode(GL_MODELVIEW); glLoadIdentity();

        glCullFace(GL_FRONT);


        glColor3ub(0,0,0);

        glPushMatrix();
        glTranslated(40,720 - .75*(720 - 1.5*H) + INTRO,0);
        glScaled(1.5,-1.5,1);

        for (int i = 225; i == 225; i -= 85){
            if (dead){ glColor3ub(i,0,0); }
            else{      glColor3ub(i,i,i); }

            //glColor4ub(0,0,0,255-i);

            glPushMatrix();
            glTranslated(.5*W,0,0);
            //glTranslated(player.num.c().x,player.num.c().y,0);
            double s = (100. - i/64.)/100.;
            glScaled(s,s,s);
            glTranslated(-.5*W,0,0);
            //glTranslated(-player.num.c().x,-player.num.c().y,0);

            //double s = -i/32.;
            //glTranslated(s,s,s);

            glCallList(world);

            glPopMatrix();
        }

        //printf("HERE!\r");

        //glColor3ub(255,0,0);
        glColor3ub(0,0,0);


        glBegin(GL_QUADS);
        player.render();
        if (!dead){ player.renderEye(); }
        glEnd();
        for (int i = 0; i < enemies.size(); i++){
            glColor3ub(0,0,0);
            glBegin(GL_QUADS);
            enemies[i].render();
            enemies[i].renderEye();
            glEnd();

            snprintf(str,2,"%i", enemies[i].lives);

            if (!dead){
                glPushMatrix();
                glTranslated(enemies[i].num.c().x - font.getLength(str), enemies[i].num.c().y + 6,0);
                glScaled(1.5,-1.5,1);
                glCullFace(GL_BACK);
                glColor3ub(255,255,255);
                font.renderWithColor(str,0,0,255,0,255,255);
                glCullFace(GL_FRONT);
                glPopMatrix();
            }
        }

        for (int i = 0; i < birds.size(); i++){
            glColor3ub(0,0,0);
            glBegin(GL_QUADS);
            birds[i].render();
            birds[i].renderEye();
            glEnd();

            snprintf(str,2,"%i", birds[i].lives);

            if (!dead){
                glPushMatrix();
                glTranslated(birds[i].num.c().x - .5*N*font.getLength(str), birds[i].num.c().y + N*3.5,0);
                glScaled(1.5,-1.5,1);
                glCullFace(GL_BACK);
                glColor3ub(255,255,255);
                font.renderWithColor(str,0,0,255,0,255,255);
                glCullFace(GL_FRONT);
                glPopMatrix();
            }
        }

        for (int i = 0; i < snakes.size(); i++){
            glColor3ub(0,0,0);
            glBegin(GL_QUADS);
            snakes[i].render();
            snakes[i].renderEye();
            glEnd();

            snprintf(str,2,"%i", snakes[i].lives);

            if (!dead){
                glPushMatrix();
                glTranslated(snakes[i].num.c().x - .5*N*font.getLength(str), snakes[i].num.c().y + N*3.5,0);
                glScaled(1.5,-1.5,1);
                glCullFace(GL_BACK);
                glColor3ub(255,255,255);
                font.renderWithColor(str,0,0,255,0,255,255);
                glCullFace(GL_FRONT);
                glPopMatrix();
            }
        }

        for (int i = 0; i < jumpers.size(); i++){
            glColor3ub(0,0,0);
            glBegin(GL_QUADS);
            jumpers[i].render();
            jumpers[i].renderEye();
            glEnd();

            snprintf(str,2,"%i", jumpers[i].lives);

            if (!dead){
                glPushMatrix();
                glTranslated(jumpers[i].num.c().x - .5*N*font.getLength(str), jumpers[i].num.c().y + N*3.5,0);
                glScaled(1.5,-1.5,1);
                glCullFace(GL_BACK);
                glColor3ub(255,255,255);
                font.renderWithColor(str,0,0,255,0,255,255);
                glCullFace(GL_FRONT);
                glPopMatrix();
            }
        }

        glColor3ub(0,0,0);

        glBegin(GL_QUADS);
        glVertex2d(-B,0);
        glVertex2d(W+B,0);
        glVertex2d(W+B,-B);
        glVertex2d(-B,-B);

        glVertex2d(-B,H+B);
        glVertex2d(W+B,H+B);
        glVertex2d(W+B,H);
        glVertex2d(-B,H);

        glVertex2d(-B,H+B);
        glVertex2d(0,H+B);
        glVertex2d(0,-B);
        glVertex2d(-B,-B);

        glVertex2d(W,H+B);
        glVertex2d(W+B,H+B);
        glVertex2d(W+B,-B);
        glVertex2d(W,-B);
        glEnd();

        if (INTRO){
            for (int i = 0; i < 7; i++){
                glPushMatrix();
                glTranslated(W*.5 - font.getLength(info[i]), H + 10 + 50*(7-i),0);
                glScaled(2,-2,1);
                glCullFace(GL_BACK);
                glColor3ub(255,255,255);
                font.renderWithColor(info[i],0,0,0,0,0,255);
                glCullFace(GL_FRONT);
                glPopMatrix();
            }
        }

        glColor3ub(0,0,0);

        for (int i = level; i < level + 2; i++){
            snprintf(str, 64, "LEVEL %i", i);
            glPushMatrix();
            glTranslated(W*.5 - 2*font.getLength(str) - (level - i)*W, H - 16,0);
            glScaled(4,-4,1);
            glCullFace(GL_BACK);
            font.renderWithColor(str,0,0,0,0,0,255);
            glCullFace(GL_FRONT);
            glPopMatrix();
        }

        if (!((int)tolevel%5) && checkx > -.9){

            glPushMatrix();
            glTranslated(W*.5 - font.getLength(check) + (checkx)*W, H - 64,0);
            glScaled(2,-2,1);
            glCullFace(GL_BACK);
            font.renderWithColor(check,0,0,0,0,0,255);
            glCullFace(GL_FRONT);
            glPopMatrix();
        }

        if (dead){
            glPushMatrix();
            glTranslated(W*.5 - 16*font.getLength("DEAD!"), H*.5 + 16*7,0);
            glScaled(32,-32,1);
            glCullFace(GL_BACK);
            font.renderWithColor("DEAD!",0,0,0,0,0,255);
            glCullFace(GL_FRONT);
            glPopMatrix();
        }

//        glBegin(GL_LINES);
//        player.num.e.line();
//        player.num.c().line();
//        player.num.b.line();
//        glEnd();
//
//        //glPushMatrix();
//        //glTranslated(player.num.e.x, player.num.e.y,0);
//
//        glColor3ub(0,0,255);
//        glBegin(GL_LINES);
//        (player.num.e + player.base).draw();
//        (player.num.e + player.sword).draw();
//        //(player.base).draw();
//        //(player.sword).draw();
//        glEnd();

        //glPopMatrix();

        //player.num.c().print();

        glColor3ub(0,0,0);
        pc.render();

        glPopMatrix();

        //gluLookAt()

        glMatrixMode(GL_MODELVIEW);
        glLoadIdentity();

        glCullFace(GL_BACK);

        snprintf(str, 128, "FPS: %i\n", window.cap.fpsv);

        glColor3ub(255,255,255);

        glPushMatrix();
        glScaled(2,2,1);
        font.renderWithColor(str,2,2,255,255,255,255);
        glPopMatrix();

        glCullFace(GL_FRONT);

        ///glPopMatrix();

        window.cap.update();       //restrain framerate
        //cap.fps();          //display framerate

        SDL_GL_SwapBuffers();           //Display to screen

    }
}

