#ifndef __INCLUDEGUARD__particle_h
#define __INCLUDEGUARD__particle_h

#include "include.h"
#include "geometry.h"
#include "math.h"

enum PARTICLEKINDS {PART=0, DEATH, WIND, WATER, SPLASH, KEY, AIR};

struct PARTICLE{
	VECTOR pos;
	VECTOR dpos;
	unsigned short iter;
	unsigned char rand;
	unsigned char kind;
	unsigned char size;
};

struct PCONTROLLER{
	std::vector<PARTICLE> particles;

	unsigned short iter;

	double waterLvl;

	VECTOR ddpos[4];

	PCONTROLLER(double _waterLvl);
	void addOne(unsigned char kind, VECTOR at);
	void addAtPoint(unsigned char kind, VECTOR at, int num);
	void addInArea(unsigned char kind, VECTOR a, VECTOR b, int num, bool spec=true);
	void addInQuad(unsigned char kind, QUAD quad, int num);
	void tick();
	void render();
};

#endif

